<template>
    <div>
        <div class="main-container">
            <video-info-tab :team-users="teamUsers"
                            :video-info="videoInfo"
                            :comments="comments"
                            :assets="assets"
            />
        </div>
        <video-player class="video-player"
                      ref="videoPlayer"
                      :options="playerOptions"
                      :playsinline="true"

                      @timeupdate="onPlayerTimeupdate($event)">
        </video-player>
        <div class="main-container">

            <div class="comments-list">
                <div class="comments-list__item" v-for="data in comments">
                    <div class="comments-list__time">{{ data.comment.video_time }}</div>
                    <div class="comments-list__comment">
                        <div class="comments-list__comment__date">{{ data.comment.created_at }}</div>
                        <div class="comments-list__comment__user-name">{{ data.comment.user.surname }} {{ data.comment.user.name }}
                        </div>
                        <p class="comments-list__comment__text" v-if="!edit || data.comment.id != commentId">{{ data.comment.comment }}</p>
                        <input type="text"
                               v-if="data.comment.id == commentId"
                               class="input__text input__text--underline"
                               :value="data.comment.comment"
                               @keyup.enter="editComment(data.comment.id, $event)"
                        />
                    </div>
                    <div class="comments-list__buttons" v-if="userData.id == data.comment.user.id">
                        <button class="comments-list__buttons__edit" @click="startEdit(data.comment.id)">
                            <i class="fa fa-pencil" aria-hidden="true"></i>
                        </button>

                        <button class="comments-list__buttons__delete" @click="deleteDialogMethod(data.comment.id)">
                            <i class="fa fa-trash-o" aria-hidden="true"></i>
                        </button>
                    </div>
                </div>
            </div>

            <el-dialog
                    :visible.sync="deleteDialog"
                    width="30%"
                    center>
                <div class="dialog">
                    <p class="dialog__text">
                        Are you sure you want <br>
                        to delete this comment.
                    </p>

                    <div class="dialog__btn">
                        <button class="btn btn__primary btn__primary--uppercase" @click="deleteComment">
                            Yes, delete
                        </button>

                        <button class="btn btn__none" @click="deleteDialog = false">
                            cancel
                        </button>
                    </div>
                </div>
            </el-dialog>

            <div class="comment" v-if="!this.videoInfo.video_data.status">
                <span class="comment__time">{{ currentTime }}</span>
                <input type="text"
                       placeholder="Write comment here..."
                       class="comment__text"
                       @focus="stopVideo"
                       @focusout="playVideo"
                       @keyup.enter="addComment"
                />
            </div>
        </div>

        <div class="approvo" v-if="userData.permission.publish && !videoInfo.video_data.status">
            <div class="main-container">
                <div class="approvo__text">
                    Once you have fully reviewed the file, <br>
                    you can <strong>approve</strong> it, by clicking the button. <br>
                    BTI Studios will be informed of it, and will send <br>
                    you the files for diffusion. <br>
                    The screener will then appear in the <br>
                    <a href="#">approved files</a> section.
                    <br>
                    <br>
                    In case any further modifications apply <strong>after</strong> <br>
                    the screener has been approved, please contact <br>
                    BTI Sdudios.
                </div>
                <div class="approvo__btn">
                    <button class="btn btn__primary btn__primary--uppercase" @click="approvoStatus = true">
                        approvo this file
                    </button>
                </div>
            </div>
        </div>

        <el-dialog
                :visible.sync="approvoStatus"
                width="30%"
                center>
            <div class="dialog">
                <p class="dialog__text">
                    Are you sure you want <br>
                    to approve this file? <br>
                </p>

                <div class="dialog__btn">
                    <button class="btn btn__primary btn__primary--uppercase" @click="approvo">
                        Yes, approve
                    </button>

                    <button class="btn btn__none" @click="approvoStatus = false">
                        cancel
                    </button>
                </div>
            </div>
        </el-dialog>

        <el-dialog
                :visible.sync="finish"
                width="30%"
                center>
            <div class="dialog">
                <p class="dialog__text">
                    Your comments have been submitted <br>
                    to the BTI Studios team. <br>
                    <br>
                    You can now view this screener <br>
                    in the completed reviews section.
                </p>

                <div class="dialog__btn">
                    <button class="btn btn__primary btn__primary--uppercase" @click="redirect('/home')">
                        home
                    </button>
                </div>
            </div>
        </el-dialog>
    </div>
</template>

<script>
    import 'video.js/dist/video-js.css'

    import VideoInfoTab from './VideoInfoTab'

    import {videoPlayer} from 'vue-video-player'

    import {videoTimeFormat} from '../../helpers/date'

    import getData from '../../mixins/getData'

    export default {
        name: 'VideoPage',
        components: {
            VideoInfoTab,
            videoPlayer
        },
        props: ['videoTree', 'defaultComments', 'teamUsers', 'videoInfo', 'userData', 'assets', 'videoFolderName'],
        mixins: [getData],
        data() {
            return {
                playerOptions: {
                    playbackRates: [0.7, 1.0, 1.5, 2.0],
                    sources: [{
                        src: '/videos/' + this.videoTree.path
                    }]
                },
                currentTime: '00:00:00',
                comments: this.defaultComments,
                approvoStatus: false,
                finish: false,
                edit: false,
                commentId: 0,
                deleteId: 0,
                deleteDialog: false,
            }
        },
        computed: {
            player() {
                return this.$refs.videoPlayer.player
            }
        },
        created() {
            if (this.videoInfo.video_data.status) this.finish = true
        },
        methods: {
            onPlayerTimeupdate(player) {
                this.currentTime = videoTimeFormat(player.currentTime())
            },
            stopVideo() {
                this.player.pause()
            },
            playVideo() {
                this.player.play()
            },
            addComment(event) {
                this.asyncGetData({
                    method: 'POST',
                    url: 'add/comment',
                    data: {
                        video_id: this.videoInfo.video_data.id,
                        comment: event.target.value,
                        video_time: this.currentTime
                    }
                }).then(response => {
                    if (response.status) {

                        event.target.value = ''

                        this.comments = response.data

                        // Success message
                        this.$message({
                            message: 'comment successfully added.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            },
            approvo() {
                this.asyncGetData({
                    method: 'POST',
                    url: 'approvo/video',
                    data: {
                        id: this.videoInfo.video_data.id
                    }
                }).then(response => {
                    if (response.status) {
                        this.approvoStatus = false
                        this.finish = true

                    }
                })
            },
            redirect(path) {
                window.location.href = path
            },
            deleteDialogMethod(id) {
                this.deleteId = id
                this.deleteDialog = true
            },
            deleteComment() {
                this.asyncGetData({
                    method: 'DELETE',
                    url: 'delete/comment',
                    data: {id: this.deleteId}
                }).then(response => {
                    if (response.status) {
                        this.comments = response.data
                        this.deleteDialog = false
                        // Success message
                        this.$message({
                            message: 'comment successfully deleted.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            },
            startEdit(commentId) {
                this.commentId = commentId
                this.edit = true
            },
            editComment(commentId, event) {
                this.asyncGetData({
                    method: 'PUT',
                    url: 'edit/comment',
                    data: {
                        commentId: commentId,
                        comment: event.target.value
                    }
                }).then(response => {
                    if (response.status) {
                        this.comments = response.data
                        this.edit = false
                        this.commentId = 0
                        // Success message
                        this.$message({
                            message: 'comment successfully edited.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            }
        }
    }
</script>

<style scoped>

</style>